/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.flags;


import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * FreezeMode defines if freeze should be enabled or disabled in a Region
 */
@Getter
@AllArgsConstructor
public enum FreezeMode implements Flag.Value<FreezeMode> {

    ACTIVE("FLAG_FREEZE_ACTIVE"),
    INACTIVE("FLAG_FREEZE_INACTIVE");

    private static FreezeMode[] values;
    private final String chatValue;

    @Override
    public FreezeMode[] getValues() {
        if (FreezeMode.values == null) {
            FreezeMode.values = FreezeMode.values();
        }
        return FreezeMode.values;
    }

    @Override
    public FreezeMode getValue() {
        return this;
    }

    @Override
    public FreezeMode getValueOf(final String name) {
        try {
            return FreezeMode.valueOf(name.toUpperCase());
        } catch (IllegalArgumentException e) {
            if (name.equalsIgnoreCase("false")) {
                return FreezeMode.INACTIVE;
            }
            return FreezeMode.INACTIVE;
        }
    }
}